Loading...
Searching...
No Matches
ObjectRecognition Class Reference

`#include </build/pcl-KfHoN9/pcl-1.15.0+dfsg/doc/tutorials/content/sources/iccv2011/include/object_recognition.h>`

## Public Member Functions

| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &filenames)
const ObjectModel & | recognizeObject (const PointCloudPtr &query_cloud)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &query_cloud)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const
| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &)
const ObjectModel & | recognizeObject (const PointCloudPtr &)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const
| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &filenames)
const ObjectModel & | recognizeObject (const PointCloudPtr &query_cloud)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &query_cloud)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const

## Protected Member Functions

PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const
PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const
PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const

## Protected Attributes

ObjectRecognitionParameters | params_
std::vector< ObjectModel > | models_
GlobalDescriptorsPtr | descriptors_
pcl::KdTreeFLANN< GlobalDescriptorT >::Ptr | kdtree_

## Detailed Description

Definition at line 56 of file object_recognition.h.

## Constructor & Destructor Documentation

## ObjectRecognition() [1/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 59 of file object_recognition.h.

## ObjectRecognition() [2/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 58 of file object_recognition.h.

## ObjectRecognition() [3/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 58 of file object_recognition.h.

## Member Function Documentation

## alignModelPoints() [1/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 175 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

Referenced by recognizeAndAlignPoints().

## alignModelPoints() [2/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 131 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

## alignModelPoints() [3/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 174 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

## applyFiltersAndSegment() [1/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 138 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

Referenced by constructObjectModel().

## applyFiltersAndSegment() [2/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 94 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

## applyFiltersAndSegment() [3/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 137 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

## constructObjectModel() [1/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 126 of file object_recognition.h.

References applyFiltersAndSegment(), estimateFeatures(), ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, params_, and ObjectModel::points.

Referenced by populateDatabase(), recognizeAndAlignPoints(), and recognizeObject().

## constructObjectModel() [2/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 82 of file object_recognition.h.

References applyFiltersAndSegment(), estimateFeatures(), ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, params_, and ObjectModel::points.

## constructObjectModel() [3/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 125 of file object_recognition.h.

References applyFiltersAndSegment(), estimateFeatures(), ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, params_, and ObjectModel::points.

## estimateFeatures() [1/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 158 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

Referenced by constructObjectModel().

## estimateFeatures() [2/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 114 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

## estimateFeatures() [3/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 157 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

## populateDatabase() [1/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & |  | ) |

inline

Definition at line 62 of file object_recognition.h.

## populateDatabase() [2/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & | filenames | ) |

inline

Definition at line 63 of file object_recognition.h.

References constructObjectModel(), descriptors_, kdtree_, and models_.

## populateDatabase() [3/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & | filenames | ) |

inline

Definition at line 62 of file object_recognition.h.

References constructObjectModel(), descriptors_, kdtree_, and models_.

## recognizeAndAlignPoints() [1/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & |  | ) |

inline

Definition at line 74 of file object_recognition.h.

## recognizeAndAlignPoints() [2/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 109 of file object_recognition.h.

References alignModelPoints(), constructObjectModel(), ObjectModel::global_descriptor, kdtree_, models_, and params_.

## recognizeAndAlignPoints() [3/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 108 of file object_recognition.h.

References alignModelPoints(), constructObjectModel(), ObjectModel::global_descriptor, kdtree_, models_, and params_.

## recognizeObject() [1/3]

const ObjectModel & ObjectRecognition::recognizeObject | ( | const PointCloudPtr & |  | ) |

inline

Definition at line 67 of file object_recognition.h.

References models_.

## recognizeObject() [2/3]

const ObjectModel & ObjectRecognition::recognizeObject | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 94 of file object_recognition.h.

References constructObjectModel(), ObjectModel::global_descriptor, kdtree_, and models_.

## recognizeObject() [3/3]

const ObjectModel & ObjectRecognition::recognizeObject | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 93 of file object_recognition.h.

References constructObjectModel(), ObjectModel::global_descriptor, kdtree_, and models_.

## Member Data Documentation

## descriptors_

GlobalDescriptorsPtr ObjectRecognition::descriptors_

protected

Definition at line 197 of file object_recognition.h.

Referenced by populateDatabase().

## kdtree_

pcl::KdTreeFLANN< GlobalDescriptorT >::Ptr ObjectRecognition::kdtree_

protected

Definition at line 198 of file object_recognition.h.

Referenced by populateDatabase(), recognizeAndAlignPoints(), and recognizeObject().

## models_

std::vector< ObjectModel > ObjectRecognition::models_

protected

Definition at line 196 of file object_recognition.h.

Referenced by populateDatabase(), recognizeAndAlignPoints(), recognizeObject(), and recognizeObject().

## params_

ObjectRecognitionParameters ObjectRecognition::params_

protected

Definition at line 195 of file object_recognition.h.

Referenced by constructObjectModel(), and recognizeAndAlignPoints().

The documentation for this class was generated from the following files:

- /build/pcl-KfHoN9/pcl-1.15.0+dfsg/doc/tutorials/content/sources/iccv2011/include/object_recognition.h
- /build/pcl-KfHoN9/pcl-1.15.0+dfsg/doc/tutorials/content/sources/iros2011/include/object_recognition.h
- /build/pcl-KfHoN9/pcl-1.15.0+dfsg/doc/tutorials/content/sources/iros2011/include/solution/object_recognition.h